package org.rhq.enterprise.gui.coregui.client.gwt;

import org.rhq.core.domain.alert.Alert;
import org.rhq.core.domain.alert.AlertDefinition;
import org.rhq.core.domain.authz.Role;
import org.rhq.core.domain.criteria.AlertCriteria;
import org.rhq.core.domain.criteria.AlertDefinitionCriteria;
import org.rhq.core.domain.criteria.RoleCriteria;
import org.rhq.core.domain.util.PageList;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface AlertGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.AlertGWTService
     */
    void findAlertsByCriteria( org.rhq.core.domain.criteria.AlertCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.alert.Alert>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.AlertGWTService
     */
    void deleteResourceAlerts( java.lang.Integer[] alertIds, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.AlertGWTService
     */
    void acknowledgeResourceAlerts( java.lang.Integer[] alertIds, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.AlertGWTService
     */
    void findAlertDefinitionsByCriteria( org.rhq.core.domain.criteria.AlertDefinitionCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.alert.AlertDefinition>> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static AlertGWTServiceAsync instance;

        public static final AlertGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (AlertGWTServiceAsync) GWT.create( AlertGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "AlertGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
