package org.rhq.enterprise.gui.coregui.client.gwt;

import org.rhq.core.domain.auth.Subject;
import org.rhq.core.domain.configuration.Configuration;
import org.rhq.core.domain.configuration.PluginConfigurationUpdate;
import org.rhq.core.domain.configuration.RawConfiguration;
import org.rhq.core.domain.configuration.ResourceConfigurationUpdate;
import org.rhq.core.domain.configuration.definition.ConfigurationDefinition;
import org.rhq.core.domain.util.PageList;
import org.rhq.enterprise.server.configuration.ConfigurationUpdateStillInProgressException;
import com.google.gwt.user.client.rpc.RemoteServiceRelativePath;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface ConfigurationGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void getPluginConfiguration( int resourceId, AsyncCallback<org.rhq.core.domain.configuration.Configuration> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void getPluginConfigurationDefinition( int resourceTypeId, AsyncCallback<org.rhq.core.domain.configuration.definition.ConfigurationDefinition> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void getResourceConfiguration( int resourceId, AsyncCallback<org.rhq.core.domain.configuration.Configuration> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void getResourceConfigurationDefinition( int resourceTypeId, AsyncCallback<org.rhq.core.domain.configuration.definition.ConfigurationDefinition> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void findResourceConfigurationUpdates( int resourceId, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.configuration.ResourceConfigurationUpdate>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void updateResourceConfiguration( int resourceId, org.rhq.core.domain.configuration.Configuration configuration, AsyncCallback<org.rhq.core.domain.configuration.ResourceConfigurationUpdate> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void updatePluginConfiguration( int resourceId, org.rhq.core.domain.configuration.Configuration configuration, AsyncCallback<org.rhq.core.domain.configuration.PluginConfigurationUpdate> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void dummy( org.rhq.core.domain.configuration.RawConfiguration config, AsyncCallback<org.rhq.core.domain.configuration.RawConfiguration> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static ConfigurationGWTServiceAsync instance;

        public static final ConfigurationGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (ConfigurationGWTServiceAsync) GWT.create( ConfigurationGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "ConfigurationGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
