package org.rhq.enterprise.gui.coregui.client.gwt;

import java.util.List;
import java.util.Set;
import com.google.gwt.user.client.rpc.RemoteServiceRelativePath;
import org.rhq.core.domain.measurement.DisplayType;
import org.rhq.core.domain.measurement.MeasurementData;
import org.rhq.core.domain.measurement.MeasurementDataTrait;
import org.rhq.core.domain.measurement.calltime.CallTimeDataComposite;
import org.rhq.core.domain.measurement.composite.MeasurementDataNumericHighLowComposite;
import org.rhq.core.domain.util.PageControl;
import org.rhq.core.domain.util.PageList;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface MeasurementDataGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void findCurrentTraitsForResource( int resourceId, org.rhq.core.domain.measurement.DisplayType displayType, AsyncCallback<java.util.List<org.rhq.core.domain.measurement.MeasurementDataTrait>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void findLiveData( int resourceId, int[] definitionIds, AsyncCallback<java.util.Set<org.rhq.core.domain.measurement.MeasurementData>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void findDataForResource( int resourceId, int[] definitionIds, long beginTime, long endTime, int numPoints, AsyncCallback<java.util.List<java.util.List<org.rhq.core.domain.measurement.composite.MeasurementDataNumericHighLowComposite>>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void findCallTimeDataForResource( int scheduleId, long start, long end, org.rhq.core.domain.util.PageControl pageControl, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.measurement.calltime.CallTimeDataComposite>> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static MeasurementDataGWTServiceAsync instance;

        public static final MeasurementDataGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (MeasurementDataGWTServiceAsync) GWT.create( MeasurementDataGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "MeasurementDataGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
