package org.rhq.enterprise.gui.coregui.client.gwt;

import org.rhq.core.domain.auth.Subject;
import org.rhq.core.domain.resource.InventorySummary;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface ResourceBossGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceBossGWTService
     */
    void getInventorySummaryForLoggedInUser( AsyncCallback<org.rhq.core.domain.resource.InventorySummary> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceBossGWTService
     */
    void getInventorySummary( org.rhq.core.domain.auth.Subject user, AsyncCallback<org.rhq.core.domain.resource.InventorySummary> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static ResourceBossGWTServiceAsync instance;

        public static final ResourceBossGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (ResourceBossGWTServiceAsync) GWT.create( ResourceBossGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "ResourceBossGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
