package org.rhq.enterprise.gui.coregui.client.gwt;

import java.util.List;
import org.rhq.core.domain.criteria.SavedSearchCriteria;
import org.rhq.core.domain.search.SavedSearch;
import org.rhq.core.domain.search.SearchSubsystem;
import org.rhq.core.domain.search.SearchSuggestion;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface SearchGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SearchGWTService
     */
    void getTabAwareSuggestions( org.rhq.core.domain.search.SearchSubsystem searchSubsystem, java.lang.String expression, int caretPosition, java.lang.String tab, AsyncCallback<java.util.List<org.rhq.core.domain.search.SearchSuggestion>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SearchGWTService
     */
    void getSuggestions( org.rhq.core.domain.search.SearchSubsystem searchSubsystem, java.lang.String expression, int caretPosition, AsyncCallback<java.util.List<org.rhq.core.domain.search.SearchSuggestion>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SearchGWTService
     */
    void createSavedSearch( org.rhq.core.domain.search.SavedSearch savedSearch, AsyncCallback<java.lang.Integer> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SearchGWTService
     */
    void updateSavedSearch( org.rhq.core.domain.search.SavedSearch savedSearch, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SearchGWTService
     */
    void deleteSavedSearch( int savedSearchId, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SearchGWTService
     */
    void findSavedSearchesByCriteria( org.rhq.core.domain.criteria.SavedSearchCriteria criteria, AsyncCallback<java.util.List<org.rhq.core.domain.search.SavedSearch>> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static SearchGWTServiceAsync instance;

        public static final SearchGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (SearchGWTServiceAsync) GWT.create( SearchGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "SearchGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
