package org.rhq.enterprise.gui.coregui.client.gwt;

import java.util.Set;
import org.rhq.core.domain.auth.Subject;
import org.rhq.core.domain.criteria.TagCriteria;
import org.rhq.core.domain.tagging.Tag;
import org.rhq.core.domain.tagging.compsite.TagReportComposite;
import org.rhq.core.domain.util.PageList;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface TagGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.TagGWTService
     */
    void findTagsByCriteria( org.rhq.core.domain.criteria.TagCriteria tagCriteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.tagging.Tag>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.TagGWTService
     */
    void addTags( java.util.Set<org.rhq.core.domain.tagging.Tag> tags, AsyncCallback<java.util.Set<org.rhq.core.domain.tagging.Tag>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.TagGWTService
     */
    void removeTags( java.util.Set<org.rhq.core.domain.tagging.Tag> tags, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.TagGWTService
     */
    void updateResourceTags( int resourceId, java.util.Set<org.rhq.core.domain.tagging.Tag> tags, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.TagGWTService
     */
    void updateResourceGroupTags( int resourceGroupId, java.util.Set<org.rhq.core.domain.tagging.Tag> tags, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.TagGWTService
     */
    void updateBundleTags( int bundleId, java.util.Set<org.rhq.core.domain.tagging.Tag> tags, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.TagGWTService
     */
    void updateBundleVersionTags( int bundleVersionId, java.util.Set<org.rhq.core.domain.tagging.Tag> tags, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.TagGWTService
     */
    void updateBundleDeploymentTags( int bundleDeploymentId, java.util.Set<org.rhq.core.domain.tagging.Tag> tags, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.TagGWTService
     */
    void updateBundleDestinationTags( int bundleDestinationId, java.util.Set<org.rhq.core.domain.tagging.Tag> tags, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.TagGWTService
     */
    void findTagReportCompositesByCriteria( org.rhq.core.domain.criteria.TagCriteria tagCriteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.tagging.compsite.TagReportComposite>> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static TagGWTServiceAsync instance;

        public static final TagGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (TagGWTServiceAsync) GWT.create( TagGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "TagGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
